module Queue1 (Queue, empty, isEmpty, join, front, back)
where
    newtype Queue a = MkQ [a]
	
    empty :: Queue a
    empty = MkQ []
	
    isEmpty :: Queue a -> Bool
    isEmpty (MkQ xs) = null xs
	
    join :: a -> Queue a -> Queue a
    join x (MkQ ys) = MkQ (ys ++ [x])
	
    front :: Queue a -> a
    front (MkQ (x:xs)) = x
	
    back :: Queue a -> Queue a
    back (MkQ (x:xs)) = MkQ xs

    instance Show a => Show (Queue a) where show (MkQ (xs)) = show (xs)